//
//  CHTRemoteCalls.m
//  Chat
//
//  Created by Adam Burkepile on 9/9/13.
//  Copyright (c) 2013 Adam Burkepile. All rights reserved.
//

#import "CHTRemoteCalls.h"

@implementation CHTRemoteCalls
+ (void)getChats:(void(^)(NSArray* chats))afterBlock {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        NSURLRequest* urlRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:address]];
        NSURLResponse* response;
        NSError* err;
        NSData* data = [NSURLConnection sendSynchronousRequest:urlRequest
                                                   returningResponse:&response
                                                               error:&err];
        
        if (data) {
            id items = [NSJSONSerialization JSONObjectWithData:data
                                                       options:0
                                                         error:&err];
            
            if (afterBlock) {
                afterBlock(items);
            }
        }
    });
}

+ (void)postChat:(NSString*)message from:(NSString*)name withBlock:(void(^)(void))afterBlock {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        NSMutableURLRequest* urlRequest = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:address]];
        [urlRequest setHTTPMethod:@"POST"];
        NSString *postString = [NSString stringWithFormat:@"name=%@&message=%@",name,message];
        [urlRequest setHTTPBody:[[postString stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding] dataUsingEncoding:NSUTF8StringEncoding]];
        
        NSURLResponse* response;
        NSError* err;
        NSData* data = [NSURLConnection sendSynchronousRequest:urlRequest
                                             returningResponse:&response
                                                         error:&err];
        
        if (afterBlock) {
            afterBlock();
        }
    });
}

@end
