//
//  CHTViewController.m
//  Chat
//
//  Created by Adam Burkepile on 9/9/13.
//  Copyright (c) 2013 Adam Burkepile. All rights reserved.
//

#import "CHTViewController.h"
#import "CHTRemoteCalls.h"

@interface CHTViewController ()
{
    NSTimer* updateTimer;
}
@end

@implementation CHTViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    updateTimer = [NSTimer timerWithTimeInterval:10.0
                                          target:self
                                        selector:@selector(update:)
                                        userInfo:nil
                                         repeats:YES];
}

-(void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    
    [self update:nil];
    [[NSRunLoop mainRunLoop] addTimer:updateTimer forMode:NSDefaultRunLoopMode];
}

- (void)update:(NSTimer*)theTimer {
    NSLog(@"Timer fired");
    [CHTRemoteCalls getChats:^(NSArray *chats) {
        __block NSMutableString* message = [NSMutableString stringWithString:@""];
        
        [chats enumerateObjectsUsingBlock:^(id obj, NSUInteger idx, BOOL *stop) {
            [message appendFormat:@"%@: %@\n",[obj objectForKey:@"n"],[obj objectForKey:@"m"]];
        }];
        
        dispatch_async(dispatch_get_main_queue(), ^{
            self.ibChatView.text = message;
            [self.ibChatView scrollRectToVisible:CGRectMake(0.0, self.ibChatView.contentSize.height-10.0, 1.0, 1.0) animated:YES];
        });
    }];
}

-(BOOL)textFieldShouldReturn:(UITextField *)textField {
    if (textField == self.ibName) {
        [self.ibMessage becomeFirstResponder];
    }
    else if (textField == self.ibMessage) {
        [self ibaSend:nil];
    }
    
    return YES;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)ibaSend:(id)sender {
    [CHTRemoteCalls postChat:self.ibMessage.text
                        from:self.ibName.text
                   withBlock:^{
                       [self update:nil];
                       dispatch_async(dispatch_get_main_queue(), ^{
                           self.ibMessage.text = @"";
                       });
                   }];
}
@end
